#include <bits/stdc++.h>

const double pi = acos(-1.0);

double d(double angle, double r) {
  return angle * pi / 180 * r;
}

double distance(double a, double b, double r) {
  return d(std::min(std::abs(a - b), 360.0 - std::abs(a - b)), r);
}

int main() {
  freopen("circles.in", "r", stdin);
  freopen("circles.out", "w", stdout);
  int n, q;
  scanf("%d%d", &n, &q);
  std::vector<double> angles(n);
  for (int i = 0; i < n; i++) {
    scanf("%lf", &angles[i]);
  }
  std::sort(angles.begin(), angles.end());
  angles.push_back(angles[0] + 360.0);
  for (int i = 0; i < q; i++) {
    double a, b;
    scanf("%lf%lf", &a, &b);
    int index = std::lower_bound(angles.begin(), angles.end(), b) - angles.begin();
    double minAns = 1e18;
    if (index == 0) {
      minAns = distance(a, angles[angles.size() - 2], 10.0) + distance(angles[angles.size() - 2], b, 20.0) + 10.0;
    } else {
      minAns = distance(a, angles[index - 1], 10.0) + distance(b, angles[index - 1], 20.0) + 10.0;
    }
    minAns = std::min(minAns, distance(a, angles[index], 10.0) + distance(angles[index], b, 20.0) + 10.0);
    printf("%.9f\n", minAns);
  }
  return 0;
}
