#include "testlib.h"
#include <sstream>
#include <algorithm>

using namespace std;

const int N = 100500;
int a[N], was[N];

int main(int argc, char * argv[])
{
	registerTestlibCmd(argc, argv);
	int n = inf.readInt();
	int k = inf.readInt();
	for (int i = 0; i < n; i++)
	{
		a[i] = inf.readInt();
	}

	int n_ans = ans.readInt();
	int n_out = ouf.readInt(0, n, "amount");
	int prev = -1;
	for (int i = 0; i < n_out; i++)
	{
		int k = ouf.readInt(1, n, "number");
		if (prev >= k)
		    quitf(_wa, "%d number is less than %d", k, k - 1);
		prev = k;
		was[k - 1] = 1;
	}

	vector <int> ans;
	for (int i = 0; i < n; i++)
	{
		if (!was[i])
		{
			ans.push_back(a[i]);
		}
	}
	sort(ans.begin(), ans.end());

	long long sum = 0;
	for (int i = 1; i < ans.size(); i++)
	{
		sum += (long long) ans[i] - ans[0];
	}
	if (sum > k || n_ans < n_out)
	{
		quitf(_wa, "incorrect certificate");
	}
	else
	{
		if (n_ans > n_out)
		{
			quitf(_fail, "juri has answer worse than participant");
		}
		quitf(_ok, "participant's answer is right");
	}
	return 0;
}
