#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

long long sum[100500];

int main()
{
	freopen("collectivism.in", "rt", stdin);
	freopen("collectivism.out", "wt", stdout);
	int n, k;
	scanf("%d%d", &n, &k);

	vector <pair <int, int> > a(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &a[i].first);
		a[i].second = i;
	}
	sort(a.begin(), a.end());

	sum[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		sum[i] = (long long) sum[i - 1] + a[i - 1].first;
	}

	pair <int, int> ans; 
	ans.first = 0;
	for (int i = 0; i < n; i++)
	{
		int l = -1, r = n - i + 1;
		while (l < r - 1)
		{
			int m = (l + r) >> 1;
			if (sum[i + m] - sum[i] - (long long) m * a[i].first <= k)
			{
				l = m;
			}
			else
			{
				r = m;
			}
		}
		if (l > ans.first)
		{
			ans.first = l;
			ans.second = i;
		}
	}

	vector <int> res;
	for (int i = 0; i < n; i++)
	{
		if (i >= ans.second && i <= ans.second + ans.first - 1)
		{
			continue;
		}
		res.push_back(a[i].second);
	}
	printf("%d\n", res.size());
	sort(res.begin(), res.end());
	for (int i = 0; i < res.size(); i++)
	{
		printf("%d ", res[i] + 1);
	}
	return 0;
}