#include "testlib.h"
#include <string>

using namespace std;
const int N = 200179;

int n;
int a[N], c[N];

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for (int i = 0; i < n; ++i)
    {
        a[i] = inf.readInt();
        c[i] = inf.readInt();
    }

	string pAns = ouf.readWord();
	if (pAns == "YES")
	{
		int roots = 0;
		for (int i = 0; i < n; ++i)
		{
			int p = ouf.readInt(0, n, "p_i");
			if (p == 0)
			{
				++roots;
				continue;
			}
			p -= 1;
			quitif(a[p] <= a[i], _wa, "incorrect certificate");
			--c[p];
			quitif(c[p] < 0, _wa, "incorrect certificate");
		}
		quitif(roots != 1, _wa, "incorrect certificate");
	} else
		quitif(pAns != "NO", _pe, "YES or NO expected, but %s found", pAns.c_str());
	
	string jAns = ans.readWord();
	if (jAns == pAns)
		quitf(_ok, "%s", pAns.c_str());
	else if (jAns == "YES")
		quitf(_wa, "participant has no answer but jury has");
	else
		quitf(_fail, "jury has no answer but participant has");

}
