#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 400179;

class MySet
{
protected:
	multiset < int > x;
	int a;
public:
	MySet() : a(0) {}
	MySet(int i) : x({i}), a(0) {}

	int getMax() const
	{
		return *x.rbegin() + a;
	}

	void add(int q)
	{
		a += q;
	}

	void merge(MySet & b)
	{
		if (sz(x) < sz(b.x))
		{
			swap(x, b.x);
			swap(a, b.a);
		}
		for (int y : b.x)
			x.insert(y + b.a - a);
	}

	void erase(int v)
	{
		x.erase(x.find(v - a));
	}
};

int n;
int a[N];
vector < int > st;
vector < int > e[N];
int p[N], pd[N];
MySet x[N];

int main()
{
#ifndef LOCAL
	freopen("deepcycle.in", "r", stdin);
	freopen("deepcycle.out", "w", stdout);
#endif

	memset(p, -1, sizeof(p));
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	memcpy(a + n, a, sizeof(int)*n);

	for (int i = n*2-1; i >= 0; --i)
	{
		while (!st.empty() && a[st.back()] <= a[i])
			st.pop_back();
		if (!st.empty())
			e[st.back()].push_back(i);
		st.push_back(i);
	}

	int ans = 0;
	for (int v = 0; v < n*2; ++v)
	{
		int rv = v - n;
		if (rv >= 0)
		{
			int cdep = 0;
			int rr = rv;
			while (p[rr] != -1)
			{
				cdep += pd[rr];
				rr = p[rr];
			}
			x[rr].erase(cdep);
			while (rv != rr)
			{
				int nrv = p[rv];
				int ncdep = cdep - pd[rv];
				p[rv] = rr;
				pd[rv] = cdep;
				cdep = ncdep;
				rv = nrv;
			}
		}
		x[v] = MySet(0);
		for (int nv : e[v])
		{
			if (nv <= v - n)
				continue;
			x[nv].add(1);
			x[v].merge(x[nv]);
			p[nv] = v;
			pd[nv] = 1;
		}
		ans = max(ans, x[v].getMax());
	}
	cout << ans + 1 << "\n";

    return 0;
}
