#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "deepcycle"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 5e5 + 5;

int n;
vector<int> rmq;
int bdv;

int segtree_set(int pos, int val) {
    pos += bdv;
    rmq[pos] = val;
    pos /= 2;
    while (pos) {
        rmq[pos] = min(rmq[pos * 2], rmq[pos * 2 + 1]);
        pos /= 2;
    }
    return 0;
}

int segtree_get(int v, int vl, int vr, int l, int r) {
    if (vr <= l || r <= vl) {
        return INF;
    }
    if (l <= vl && vr <= r) {
        return rmq[v];
    }
    int vm = (vl + vr) / 2;
    return min(segtree_get(v * 2, vl, vm, l, r), segtree_get(v * 2 + 1, vm, vr, l, r));
}

vector<int> graph[MAXN];
int parent[MAXN];
pii mem[MAXN];

pii get(int v, int last) {
    if (parent[v] >= last) {
        return {1, v};
    }
    pii tmp = get(mem[v].ss, last);
    tmp.ff += mem[v].ff;
    mem[v] = tmp;
    mem[v].ff--;
    return tmp;
}

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d", &n);

    vector<int> inp;
    vector<int> vals;
    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        inp.puba(num);
        vals.puba(num);
    }

    for (int i = 0; i < n; ++i) {
        inp.puba(inp[i]);
    }

    sort(bend(vals));
    vals.resize(unique(bend(vals)) - vals.begin());

    bdv = 1;
    while (bdv < szof(vals)) {
        bdv *= 2;
    }

    rmq.resize(bdv * 2, INF);

    for (int i = n * 2 - 1; i >= 0; --i) {
        int pos = lower_bound(bend(vals), inp[i]) - vals.begin();
        int tmp = segtree_get(1, 0, bdv, pos + 1, bdv);
        if (tmp < INF) {
            graph[tmp].puba(i);
        }
        parent[i] = tmp;
        mem[i] = {1, parent[i]};
        segtree_set(pos, i);
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, get(i, i + n).ff);
    }

    cout << ans << "\n";
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}